*                                    AVERTISSEMENT

* Le gouvernement du Canada (Statistique Canada) possde tous les droits de proprit
* intellectuelle (y compris le droit d'auteur) relatifs  ce logiciel.  Sous rserve
* des modalits dcrites ci-dessous, vous obtenez une licence non exclusive et non
* transmissible d'utilisation de ce logiciel.
*
* Ce logiciel vous est fourni  tel quel , et le titulaire ne donne aucune garantie
* expresse ou implicite, ce qui comprend les garanties de qualit marchande et de
* convenance  une fin particulire mais ne se limite pas  ces garanties.  En aucune
* circonstance le titulaire ne sera responsable de dommages indirects, particuliers ou
* conscutifs, ou d'autres dommages semblables.  Ce contrat sera automatiquement rsili,
* sans pravis, si vous omettez de respecter une quelconque des modalits du contrat.;

/*******************************************************************/
/* Date: Avril 2002                                                */
/* Modifi: Avril 2002                                             */
/*******************************************************************/

/*********************************************************************************/
/***                                                                           ***/
/***                          BOOTVARF_V20.SAS                                 ***/
/***                                                                           ***/
/*** Ce programme calcule des estimations de variance pour diffrents types    ***/
/*** d'estimations  l'aide des poids bootstrap.   l'aide de macros SAS,      ***/
/*** ce programme peut calculer des estimations de variance pour des totaux,   ***/
/*** des rapports et des diffrences de rapports.  Il peut aussi calculer des  ***/
/*** estimations de variance pour des paramtres de rgression linaire ou     ***/
/*** logistique. Ce programme peut aussi tre modifi pour s'adapter          ***/
/*** d'autres types d'analyse.                                                 ***/
/***                                                                           ***/
/*** Ce programme est divis en 2 parties.  Tout au long du programme, les     ***/
/*** changements que l'utilisateur doit apporter sont indiqus.                ***/
/***                                                                           ***/
/*** Partie 1: Dclaration des variables macros                                ***/
/***            C'est  cet endroit que l'utilisateur dfinit les variables et ***/
/***            fichiers qui seront utiliss par le programme. Certains        ***/
/***            changements doivent tre apports par l'utilisateur.           ***/
/***            C'est aussi  cet endroit que sont lus les fichiers contenant  ***/
/***            les variables  analyser et les poids bootstrap.  Les variables***/
/***             utiliser dans les analyses doivent tre dfinies par l'utili-***/
/***            sateur avant d'utiliser ce programme.                          ***/
/***                                                                           ***/
/*** Partie 2: noncs pour soumettre les macros                               ***/
/***            C'est  cet endroit que l'utilisateur doit indiquer quelle(s)  ***/
/***            analyse(s) il dsire effetuer.                                 ***/
/***            tant donn le grand nombre d'observations  analyser, il est  ***/
/***            recommand de limiter le nombre d'analyses, en particulier     ***/
/***            dans le cas de rgressions.                                    ***/
/***                                                                           ***/
/*** Ce programme fait appel au programme MACROF_V20.SAS.  MACROF_V20.SAS      ***/
/*** contient les diffrentes macros qui permettent l'estimation de la variance***/
/*** Pour une utilisation standard du programme d'estimation de la variance,   ***/
/*** aucune modification par l'usager n'est requise au programme MACROF_V20.SAS.**/
/*** Des changements peuvent tre ncessaires seulement dans quelques cas      ***/
/*** particuliers expliqus dans la partie 2 du programme.                     ***/
/***                                                                           ***/
/***                                                                           ***/
/*** Avant d'utiliser Le programme BOOTVARF_V20.SAS, l'utilisateur doit prparer**/
/*** un fichier d'analyse qui contiendra les variables  analyser.             ***/
/***                                                                           ***/
/*** Pour calculer un total, un rapport ou une diffrence entre deux rapports, ***/
/*** les estimations sont obtenues en sommant le poids des enregistrements qui ***/
/*** ont la caractristique d'intrt.  Donc, une variable indicatrice doit    ***/
/*** tre cre pour chaque variable  analyser.  Elle prendra la valeur 1     ***/
/*** lorsque l'enregistrement  la caractristique d'intrt et 0 sinon.       ***/
/***                                                                           ***/
/*** NOTE: Ce fichier ne devrait contenir que les enregistrements pour lesquels***/
/*** l'analyse est ncessaire (p.e. si l'analyse est faite pour le groupe d'ge***/
/*** 12 ans et plus, seuls les enregistrements des individus de 12 ans et plus ***/
/*** devraient tre inclus dans le fichier).                                   ***/
/*********************************************************************************/;




/*****************************************************************************/
/***                               PARTIE 1                                ***/
/*****************************************************************************/
/***                                                                       ***/
/***   Cette partie permet  l'utilisateur de spcifier les diffrents     ***/
/***   paramtres dsirs (noms de variables, noms de rpertoires, noms    ***/
/***   de fichiers, etc...)                                                ***/
/***                                                                       ***/
/*****************************************************************************/;


************************************************************************************
**  VEUILLEZ INDIQUER LE NOM DES 2 RPERTOIRES SUIVANTS (rpertoires seulement):  **  
************************************************************************************;

      libname in1 "nom_du_rpertoire_contenant_fichier_d'analyse_(tape_1)"; /* (ex: c:\data) */
      libname out "nom_du_rpertoire_o_sauvegarder_rsultats";              /* (ex: c:\output) */


****************************************************************************************
** VEUILLEZ INDIQUER LE NOM DU FICHIER D'ANALYSE (CR  L'TAPE 1) (sans extension): **    
****************************************************************************************;

      %let Mfile = in1.nom_du_fichier_d''analyse;       


******************************************************************************
** VEUILLEZ INDIQUER LE NOM DU FICHIER CONTENANT LES POIDS BOOTSTRAP:       **
**     NB: N'excuter qu'une seule des deux sries de commandes suivantes   **
**     (mettre l'autre en commentaire, ou l'effacer):                       **
******************************************************************************;

  *  EXCUTEZ CETTE PARTIE SI LES POIDS BOOTSTRAP SONT EN FORMAT SAS (enlever les " * ")
     -----------------------------------------------------------------------------------;

          *    libname in2 "nom_du_rpertoire_contenant_fichier_poids_bootstrap"; /* (ex: c:\bootstrp) */
          *    %let bsamp = in2.nom_du_fichier_SAS_contenant_les_poids_(sans_extension);

  *  EXCUTEZ CETTE PARTIE SI LES POIDS BOOTSTRAP SONT EN FORMAT ASCII (.TXT) (enlever les " * ")
     --------------------------------------------------------------------------------------------;

          *    data poidboot;
          *       %let datafid="location(rpertoire)_et_nom_du_fichier_de_poids_(avec_extension)";
          *       %include "location(rpertoire)_et_nom_du_clich_d'article_(layout)_(avec_extension)";
          *    run;
          *    %let bsamp=poidboot;


*****************************************************************************************************
** VEUILLEZ SPCIFIER LA(LES) VARIABLE(S) DE VENTILATION, SI DSIR (EX: PROVINCE, SEXE, ETC...):  ** 
**     crire le nom de la(des) variable(s) de ventilation ci-dessous.                             **
**                                                                                                 **
**  - Si l'analyse est faite pour l'ensemble des donnes incluses dans le fichier cr  l'tape 1,**
**    mettre un point (%let classes =. )                                                           **
**  - Si plus d'une variable, laisser un espace entre chacune (%let classes = var1 var2)           **
**  - NE PAS EFFACER OU METTRE EN COMMENTAIRE CETTE COMMANDE.                                      **
*****************************************************************************************************;

      %let classes = variable(s)_de_ventilation__ou__un_point ;


******************************************************************************************
** VEUILLEZ INDIQUER LE NOMBRE DE POIDS BOOTSTRAP  UTILISER:                           ** 
**     IMPORTANT:  IL EST NCESSAIRE D'UTILISER TOUS LES POIDS BOOTSTRAP AU MOMENT      **
**                 D'EFFECTUER LES ANALYSES FINALES.  LE PROGRAMME BOOTVARF_V20.SAS     **
**                 DOIT ENSUITE TRE EXCUT AU COMPLET.                                ** 
**                                                                                      **
**            - Se rfrer  l'annexe C du document pour savoir le nombre de poids      ** 
**              que contient le fichier de poids.                                       **          
**            - Pour les tests, il faut que B>= 2.                                     **
******************************************************************************************;

      %let B = nombre_de_poids__utiliser;   


*********************************************************************************
** VEUILLEZ SPCIFIER LE RPERTOIRE ET LE NOM DU FICHIER DU PROGRAMME DE MACRO **
** (LE PROGRAMME MACROF_V20.SAS SI L'USAGER N'A PAS FAIT DE MODIFICATIONS)     **
*********************************************************************************;

      %include "nom_du_repertoire_de_macrof_v20.sas\MACROF_V20.SAS";




/*****************************************************************************/
/***                               PARTIE 2                                ***/
/*****************************************************************************/
/***                                                                       ***/
/***   Cette partie permet  l'utilisateur de spcifier les diffrentes    ***/
/***   analyses dsires                                                   ***/
/***                                                                       ***/
/*****************************************************************************/


/**********************************************************************************/
/*** Les estimations de variance sont calcules  l'aide des macros SAS         ***/
/*** dfinies dans le programme MACROF_V20.SAS. Ces macros SAS peuvent tre     ***/  
/*** soumises dans ce programme, selon les besoins de l'utilisateur.            ***/
/***                                                                            ***/
/*** Pour soumettre une macro, il faut spcifier un nonc indiquant le nom de  ***/
/*** la macro  soumettre et les paramtres  utiliser.  Dans ce programme, les ***/
/*** paramtres indiquent quelles variables seront utilises.                   ***/
/***                                                                            ***/
/*** Chaque soumission d'une macro donnera une estimation de la variance d'un   ***/
/*** seul paramtre  estimer.  Si plus d'un paramtre et sa variance doivent   ***/
/*** tre calculs, il faut alors soumettre la macro  plusieurs reprises.      ***/
/***                                                                            ***/
/*** Un nonc pour chaque analyse possible apparat dans le programme. Ils     ***/
/*** sont mis en commentaire et l'usager ne doit excuter que ceux qu'il dsire.***/
/***                                                                            ***/
/***                                                                            ***/
/***  REMARQUE POUR LA DIFFRENCE DE RAPPORTS:                                  ***/
/***  ----------------------------------------                                  ***/
/***                                                                            ***/
/***     L'intervalle de confiance est calcul pour une analyse faisant         ***/
/***     une seule comparaison de rapports.  Si des comparaisons multiples sont ***/
/***     faites, la faon de calculer l'intervalle de confiance doit tenir      ***/
/***     compte de cette situation.  Pour cette raison, dans le cas de comparai-***/
/***     sons multiples, la valeur de la loi normale (Z) utilise dans le       ***/
/***     calcul de l'intervalle de confiance doit tre corrige dans la macro   ***/
/***     diff_rat du programme MACROF_V20.SAS, en utilisant, par exemple,       ***/
/***     l'approche de Bonferroni pour les comparaisons multiples.              ***/
/***                                                                            ***/
/**********************************************************************************/


* POUR OBTENIR L'ESTIMATION DE LA VARIANCE D'UN TOTAL, EXCUTER:
  -------------------------------------------------------------;

        *  %total(nom_de_la_variable);


* POUR OBTENIR L'ESTIMATION DE LA VARIANCE D'UN RAPPORT, EXCUTER:
  ---------------------------------------------------------------;

        *  %ratio(variable_au_numrateur,variable_au_dnominateur);			


* POUR OBTENIR L'ESTIMATION DE LA VARIANCE D'UNE DIFFRENCE DE RAPPORTS, EXCUTER:
  -------------------------------------------------------------------------------;
             * ATTENTION: Voir la remarque au dbut de la partie 2...                              ;
 
	    *  %diff_rat(VAR1,VAR2,VAR3,VAR4);

                     *  o:  var1   : la variable au numrateur du 1er rapport      *   
                     *       var2   : la variable au dnominateur du 1er rapport    *
                     *       var3   : la variable au numrateur du 2e rapport       *    
                     *       var4   : la variable au dnominateur du 2e rapport     *;


* POUR OBTENIR L'ESTIMATION DE LA VARIANCE DES PARAMTRES D'UNE RGRESSION, EXCUTER:
  ----------------------------------------------------------------------------------;

        * %regress(var_dpendante,variables_indpendantes_(sans virgule));
	

* POUR OBTENIR L'ESTIMATION DE LA VARIANCE DES PARAMTRES D'UNE RGRESSION LOGISTIQUE, EXCUTER:
  ---------------------------------------------------------------------------------------------;

        * %logreg(var_dpendante,variables_indpendantes_(sans virgule));



%output;  /* Affiche les rsultats  l'cran.  Ne pas modifier...  */


* POUR SAUVEGARDER LES RSULTATS DANS UN FICHIER, EXCUTER: (enlever les "*")
  ---------------------------------------------------------------------------;

        *  data out.non_du_fichier_de_rsultats;
        *    set &result ;
        *  run;


/* Fin du programme SAS BOOTVARF_V20.SAS */