**********************************************************
*                      TAPE1.SAS                        *
*                                                        *
*  Ce programme permet de crer le fichier de donnes    *
*  SAS contenant les variables ncessaires pour utiliser *
*  le programme BOOTVARF_V20.SAS                         *
**********************************************************;


LIBNAME in1 'C:\DummyCD_test';


*** Cration du fichier de donnes SAS contenant les variables et enregistrements requis 
*** pour l'analyse.  Ce fichier devrait tre le plus petit possible (contenant seulement 
*** les variables et enregistrements ncessaires) afin de rduire le temps d'excution et  
*** la mmoire requise, spcialement dans le cas des rgressions. ;
 

data in1.CD_dommy;       /* Fichier qui sera utilis avec BOOTVARF_V20.SAS */
    %let datafid="D:\Dummy\Data\Dumy_HSI.txt";
   %include "D:\Dummy\Layout\HS_I.sas";


***  Cration des variables dichotomiques    ***
*** (des exemples sont prsents ci-dessous, utilisant les variables de l'ENSP, cycle 3) ***;
            
   /* diabte */
          if CCCA_101=1 then diab=1;
          else diab=0;

   /* sexe */
          if DHHA_SEX=1 then hommes=1;
          else hommes=0;
          if DHHA_SEX=2 then femmes=1;
          else femmes=0;

   /* diabte*sexe */
          hdiab = diab * hommes;    /* hommes diabtiques */
          fdiab = diab * femmes;    /* femmes diabtiques */


     keep sampleid personid WTSAM diab hommes femmes hdiab  fdiab;

                * Il est recommand de ne conserver que les variables ncessaire        *
                * afin de diminuer le temps d'excution du programme BOOTVARF_V20.SAS.  *
                * IMPORTANT:  les variables d'identification et, si ncessaire, la(les) *
                * variable(s) de ventilation (ex: provinces, sexe) doivent tre         *
                * conserves.   La variable de poids doit aussi tre conserve si les   *
                * estimations ponctuelles sont calcules  cette tape.                 *;
             
run;



******************************************
* Calcul des estimations ponctuelles     *
* Conseill, mais non obligatoire...     *
******************************************;


proc freq data=in1.CD_dommy;
     table diab*(hommes femmes);
     weight WTSAM ;
run;

proc logistic data=in1.CD_dommy;
     model diab = hommes femmes;
     weight WTSAM ;
run;
